/* Demo showing the use of the buttonbox.

   Written by Mark Overmars
*/

#include <stdio.h>
#include <gl/device.h>
#include "forms.h"

FL_FORM *form;
FL_OBJECT *brobj, *exitobj;

void create_form()
{
  form = fl_bgn_form(FL_UP_BOX,440.0,230.0);
  brobj = fl_add_browser(FL_NORMAL_BROWSER,20.0,60.0,400.0,150.0,"");
  exitobj = fl_add_button(FL_NORMAL_BUTTON,160.0,20.0,130.0,30.0,"Exit");
  fl_end_form();
}

main()
{
  FL_OBJECT *obj;
  long dev;
  short val;
  int i;
  char str[100];
  fl_init();
  fl_show_buttonbox();
  create_form();
  fl_show_form(form,FL_PLACE_SIZE,FALSE,NULL);
  for (dev = SW0; dev<=SW31; dev++) fl_qdevice( (short) dev);
  for (i=0; i<32; i++)
    { sprintf(str,"%d",i); fl_set_buttonbox_label(i,str);}
  do
  {
    obj = fl_do_forms();
    if ( obj == FL_EVENT)
    {
      dev = fl_qread(&val);
      if (val)
	sprintf(str,"Button %d was pressed.",dev-SW0);
      else
	sprintf(str,"Button %d was released.",dev-SW0);
      fl_addto_browser(brobj,str);
    }
  } while (obj != exitobj);
  fl_hide_buttonbox();
  fl_hide_form(form);
}
