/* A demo of a moving chart */

#include <math.h>
#include "forms.h"

long func = 1;
float x = 0.0;
float step = 0.15;

FL_FORM *form;

FL_OBJECT
        *chartobj,
        *sinobj,
        *exitbut,
        *stepobj;

void set_function(FL_OBJECT *obj, long arg)
{ func = arg; fl_clear_chart(chartobj); x = 0.0;}

void set_step(FL_OBJECT *obj, long arg)
{ step = fl_get_slider_value(stepobj);}

/*************************************************/

void create_form_form()
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_NO_BOX,490.0,320.0);
  obj = fl_add_box(FL_BORDER_BOX,0.0,0.0,490.0,320.0,"");
  chartobj = obj = fl_add_chart(FL_LINE_CHART,20.0,160.0,390.0,140.0,"");
  fl_bgn_group();
  sinobj = obj = fl_add_lightbutton(FL_RADIO_BUTTON,30.0,120.0,170.0,30.0,"sin(x)");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,1);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,30.0,90.0,170.0,30.0,"sin(2x)*cos(x)");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,2);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,30.0,60.0,170.0,30.0,"sin(2x)+cos(x)");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,3);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,240.0,120.0,160.0,30.0,"sin(3x)+cos(x)");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,4);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,240.0,90.0,160.0,30.0,"sin(x)^2 + cos(x)");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,5);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,240.0,60.0,160.0,30.0,"sin(x)^3");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_function,6);
  fl_end_group();
  exitbut = obj = fl_add_button(FL_NORMAL_BUTTON,150.0,20.0,140.0,30.0,"Exit");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
  stepobj = obj = fl_add_valslider(FL_VERT_SLIDER,430.0,20.0,40.0,280.0,"");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
    fl_set_call_back(obj,set_step,0);
  fl_end_form();
}

/************************************/

float next_step()
{
  float res = 0.0;
  switch ( func)
  {
    case 1: res = sin(x); break;
    case 2: res = sin(2*x)*cos(x); break;
    case 3: res = sin(2*x)+cos(x); break;
    case 4: res = sin(3*x)+cos(x); break;
    case 5: res = sin(x)*sin(x) + cos(x); break;
    case 6: res = sin(x)*sin(x)*sin(x); break;
  }
  x += step;
  return res;
}

main()
{
  FL_OBJECT *obj;
  fl_init();
  fl_set_graphics_mode(0,1);
  create_form_form();
  fl_set_chart_bounds(chartobj,-1.5,1.5);
  fl_set_chart_maxnumb(chartobj,80);
  fl_set_chart_autosize(chartobj,FALSE);
  fl_set_button(sinobj,1);
  fl_set_slider_value(stepobj,0.15);
  fl_set_slider_bounds(stepobj,0.0,0.4);

  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  do {
    fl_insert_chart_value(chartobj,1,next_step(),"",1);
    obj = fl_check_forms();
  } while (obj != exitbut);
}

